﻿namespace GridOptionSetEditor
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinEditors;

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = InitializeGridDataSource(10);
        }

        private DataTable InitializeGridDataSource(int rows)
        {
            DataTable table = new DataTable("Table1");

            table.Columns.Add("Boolean column", typeof(Boolean));
            table.Columns.Add("Integer column", typeof(Int32));
            table.Columns.Add("DateTime column", typeof(DateTime));
            table.Columns.Add("OptionSet column", typeof(int));

            for (int index = 0; index < rows; index++)
            {
                DataRow row = table.NewRow();
                row["Boolean column"] = index % 2 == 0 ? true : false;
                row["Integer column"] = index;
                row["OptionSet column"] = 0;
                row["DateTime column"] = DateTime.Now;
                table.Rows.Add(row);
            }

            return table;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {            
            var value1 = new ValueListItem { DataValue = 1, DisplayText = "Yes" };
            var value2 = new ValueListItem { DataValue = 2, DisplayText = "No" };
            var value3 = new ValueListItem { DataValue = 3, DisplayText = "N/A" };
 
            var settings = new DefaultEditorOwnerSettings();
            settings.ValueList = new ValueList { ValueListItems = { value1, value2, value3 }}; 
 
            var editor = new OptionSetEditor(new DefaultEditorOwner(settings));

            e.Layout.Bands[0].Columns["OptionSet column"].Editor = editor;
            e.Layout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns;
        }
    }
}
